<?php
/*
Plugin Name: Deshi News Aggregator
Plugin URI: https://www.shaharia.com/wordpress-plugins/deshi-news-aggregator
Description: Show your WP site visitor all latest news from Bangladeshi news source
Version: 1.0.3
Author: Shaharia Azam
Author URI: https://www.shaharia.com
License: GPLv2 or later
Text Domain: deshi-news-aggregator
*/

/**
 * Calls from outside of Wordpress are prohibited
 */
defined( 'ABSPATH' ) || die();

/**
 * Defining all the constants
 * Don't change any of the constants otherwise entire plugin won't work
 */
define("DESHI_NEWS_AGGREGATOR_PLUGIN_ROOD_DIR", __DIR__);
define("DESHI_NEWS_AGGREGATOR_PLUGIN_SLUG", "deshi-news-aggregator");
define("DESHI_NEWS_AGGREGATOR_PLUGIN_FILE_PATH", DESHI_NEWS_AGGREGATOR_PLUGIN_ROOD_DIR . DIRECTORY_SEPARATOR . "deshi-news-aggregator.php");
define("DESHI_NEWS_AGGREGATOR_PLUGIN_SLUG_UNDERSCORED", "deshi_news_aggregator");

/**
 * Admin menu page URL define
 */
define("DESHI_NEWS_AGGREGATOR_PLUGIN_SLUG_SETTINGS_PAGE", "deshi-news-aggregator-settings");
define("DESHI_NEWS_AGGREGATOR_PLUGIN_SLUG_ABOUT_PAGE", "deshi-news-aggregator-about");

/**
 * Other important definition
 */
define("DESHI_NEWS_AGGREGATOR_PLUGIN_DB_VERSION", 1.0);
define("DESHI_NEWS_AGGREGATOR_PLUGIN_DB_TABLE_PREFIX", "DESHI_NEWS_AGGREGATOR__");

/**
 * Attaching autoload file to make our namespace work
 */
require DESHI_NEWS_AGGREGATOR_PLUGIN_ROOD_DIR . DIRECTORY_SEPARATOR . "vendor" . DIRECTORY_SEPARATOR . "autoload.php";

/**
 * Prepare admin menu
 */
add_action( 'admin_menu', array('ShahariaAzam\WPPlugin\DeshiNewsAggregator\Bootstrap','createPluginMenu' ) );

/**
 * Register custom options for later use
 */
add_action( 'admin_init', array('ShahariaAzam\WPPlugin\DeshiNewsAggregator\Bootstrap','initOptionKeys' ) );

/**
 * Prepare (Install or update DB)
 */
$db = new \ShahariaAzam\WPPlugin\DeshiNewsAggregator\DB\Prepare();

/**
 * Finally initialize the cron for optimzed site speed
 */
$st = new \ShahariaAzam\WPPlugin\DeshiNewsAggregator\Cron\ScheduledTasks();
$st->init();

$widget = new ShahariaAzam\WPPlugin\DeshiNewsAggregator\Widgets\Config();
$widget->create();