<?php

namespace ShahariaAzam\WPPlugin\DeshiNewsAggregator\Cron;

/**
 * Class GetNews
 * @package ShahariaAzam\WPPlugin\DeshiNewsAggregator\Cron
 */
class GetNews
{
    /**
     * Attach function to be executed on our get_prothom_alo_fresh_news hooks
     */
    public function hookInit()
    {
        // hook that function onto our scheduled event:
        add_action('get_prothom_alo_fresh_news', array($this, "fetch"));
    }

    // here's the function we'd like to call with our cron job
    function fetch()
    {
        //update_option("palo_opt_1", microtime());

        $response = wp_remote_get('https://na-papi-v1.shaharia.com/news/headlines/prothom-alo?utm_source=' . urlencode(site_url()));
        $api_response = json_decode(wp_remote_retrieve_body($response), true);

        self::dbInsert($api_response);
    }

    public static function dbInsert(array $newsHeadlines)
    {
        global $wpdb;

        $tableName = $wpdb->prefix . DESHI_NEWS_AGGREGATOR_PLUGIN_DB_TABLE_PREFIX . "news_headlines";

        $delete = $wpdb->query("TRUNCATE TABLE `{$tableName}`");

        foreach ($newsHeadlines as $newsHeadline) {

            $wpdb->insert(
                $tableName,
                [
                    'title' => $newsHeadline['title'],
                    'url' => $newsHeadline['url'],
                    'featured_image_url' => isset($newsHeadline['image_featured']['src']) ? $newsHeadline['image_featured']['src'] : null,
                    'api_fetched_at' => date("Y-m-d H:i:s"),
                ],
                array(
                    '%s',
                    '%s',
                    '%s',
                    '%s'
                )
            );
        }
    }
}