<?php


namespace ShahariaAzam\WPPlugin\DeshiNewsAggregator\Cron;


class ScheduledTasks
{
    public function init()
    {
        add_action('wp', array($this, 'getNewsScheduledTasksActivate'));

        //Execute cron function
        (new GetNews())->hookInit();

        //add_action('get_prothom_alo_fresh_news', array($this, "f"));

        add_filter('cron_schedules', array($this, 'customCronInterval'));
        register_deactivation_hook(DESHI_NEWS_AGGREGATOR_PLUGIN_ROOD_DIR . DIRECTORY_SEPARATOR . DESHI_NEWS_AGGREGATOR_PLUGIN_SLUG, 'getNewsScheduledTasksDeactivate');
    }

    function customCronInterval($schedules)
    {
        $schedules['six_hours'] = array(
            'interval' => 21600,
            'display' => esc_html__('Every Six Hours'),
        );

        return $schedules;
    }

    function getNewsScheduledTasksActivate()
    {
        if (!wp_next_scheduled('get_prothom_alo_fresh_news')) {
            wp_schedule_event(time(), 'six_hours', 'get_prothom_alo_fresh_news');
        }
    }

    function getNewsScheduledTasksDeactivate()
    {
        // find out when the last event was scheduled
        $timestamp = wp_next_scheduled('get_prothom_alo_fresh_news');
        // unschedule previous event if any
        wp_unschedule_event($timestamp, 'get_prothom_alo_fresh_news');
    }
}